import React, { Component } from "react";
import { connect } from "react-redux";
import * as actions from "../actions/redux-todo";

import Button from "../components/button/button";

import Form from "../components/form";

export class ReduxTodo extends Component {
	render() {
		const {
			list,
			item,
			handleChangeEvent,
			resetForm,
			editableForm,
			handleSubmitEvent,
			addHobby,
			removeHobby,
			removeItem,
			editItem,
			submitHandlerEdit
		} = this.props;
		return (
			<div
				style={{
					display: "flex"
				}}>
				<div className="list">
					{list.map(el => (
						<div className="list__item" key={el.id}>
							<Button
								text="x"
								className="list__rm-btn"
								// onClick={() => this.removeHandler(el.id)} />
								onClick={removeItem.bind(null, el.id)}
							/>
							{el.editable && (
								<Button text="edit" className="list__edit-btn" onClick={editItem.bind(null, el.id)} />
							)}
							<h4 className="list__item-title">
								{el.firstName} {el.lastName}
							</h4>
							<p className="list__item-age">Age: {el.age}</p>
							<ul className="list__item-ul">
								{el.hobby.map(elem => (
									<li className="list__item-li" key={elem}>
										{elem}
									</li>
								))}
							</ul>
						</div>
					))}
				</div>

				<Form
					rmHobby={removeHobby}
					addHobby={addHobby}
					editableForm={editableForm}
					reset={resetForm}
					onChangeEvent={handleChangeEvent}
					onSubmitEvent={editableForm ? submitHandlerEdit : handleSubmitEvent}
					values={item}
				/>
			</div>
		);
	}
}

const mapStateToProps = state => ({
	list: state.redux_todo.list,
	item: state.redux_todo.item,
	editableForm: state.redux_todo.editableForm
});

export default connect(
	mapStateToProps,
	{ ...actions }
)(ReduxTodo);
